$(document).ready(function() {

  $(document).on('formily_update_table', function (e, data) {
    var table_id = data.resource_id + '_' + data.user_id;
    var table = $('table[data-formily-form-table=' + table_id + ']');

    $.ajax({
      url: '/formily/forms/reload_formily_table',
      type: 'POST',
      data: data,
      success: function(response){
        table.replaceWith(response);
      },
      error: function(response){
        console.error(response);
      },
      complete: function(){
        $('.tooltip').hide();
        $(document).foundation();
      }
    });
  });

});