$(document).ready(function() {

  $(document).on('click', 'span[data-formily-new-response]', function(e){
    var self = $(this);
    var data = self.data('formilyNewResponse');
    var url = self.data('href');

    if(self.parents('table:first').data('formilyFlag')) {
      data.flag = true;
    }

    $.ajax({
      url: url,
      type: 'POST',
      data: data,
      success: function(){
        $(document).trigger('formily_update_table', data);
      },
      error: function(resp){
        console.error(resp.responseJSON.msg);
        alert(resp.responseJSON.msg);
      }
    });

    e.preventDefault();
  });

  $(document).on('click', 'span[data-formily-delete-response-id]', function(e){
    var self = $(this);
    var id = self.data('formilyDeleteResponseId');
    var data = self.data('formilyResponse');

    if(confirm('Are you sure you want to delete the form submission?')){
      $.ajax({
        url: FormilyRoutes.response_delete_path(id),
        data: data,
        type: 'DELETE',
        success: function(){
          $(document).trigger('formily_update_table', data);
        },
        error: function(resp){
          console.error(resp.responseJSON.msg);
          alert(resp.responseJSON.msg);
        }
      });
    }
    e.preventDefault();
  });
});
