$(document).ready(function() {

  // Show/hide section
  $(document).on('change', 'select[data-ff-name="type"]', function(){

    var self = $(this);
    var parent = self.parents('section:first');

    parent.find('section').hide(0);
    parent.find('section[data-formily="' + self.val() + '"]').show(0);

    // Set model option
    window.InputModel.type = self.val();
  });

  // For text box & textarea
  $(document).on('keyup keypress', 'input[data-ff-name], textarea[data-ff-name]', function(){
    var self = $(this);

    if(self.data('ffName') == 'tag_attributes') {
      if(self.val() == '') {
        window.InputModel.delTagAttr(self.data('ffSname'));
      } else {
        window.InputModel.setTagAttr(self.data('ffSname'), self.val());
      }
    } else {
      window.InputModel.setValue(self.data('ffName'), self.val());
    }
  });

  // For checkbox
  $(document).on('change', 'input[type=checkbox][data-ff-name]', function(){
    var self = $(this);

    if(self.data('ffName') == 'tag_attributes') {
      if(self.get(0).checked) {
        window.InputModel.setTagAttr(self.data('ffSname'), self.val());
      } else {
        window.InputModel.delTagAttr(self.data('ffSname'));
      }
    } else {
      if(self.get(0).checked) {
        window.InputModel.setValue(self.data('ffName'), self.val());
      } else {
        window.InputModel.setValue(self.data('ffName'), '');
      }
    }
  });

  $(document).on('change', 'select[data-ff-name]', function(){
    var self = $(this);

    if(self.data('ffName') == 'tag_attributes') {
      window.InputModel.setTagAttr(self.data('ffSname'), self.val());
    } else {
      window.InputModel.setValue(self.data('ffName'), self.val());
    }

    var def_input = $('section input[type="text"][data-ff-name="default_value"]');
    var tag = self.parents('section:first').find('ul.related_value_tag');

    if(self.val() == 'custom_value') {
      def_input.show(0);
      def_input.val('');
      def_input.focus();
      if (tag.length > 0) {
        tag.hide(0);
        tag.tagit('removeAll');
      }
    } else if (self.val() == 'related_value') {
      tag.show(0);
      def_input.hide(0);
    } else {
      def_input.hide(0);
      if (tag.length > 0) {
        tag.hide(0);
        tag.tagit('removeAll');
      }

    }
  });

});