// Checkbox conditioned fields

$(document).ready(function(){

  $(document).on('change', 'input[type=checkbox][data-formily-conditioned]', function(){
    var conditionedField, self = $(this);
    conditionedField = self.parent(0).find('input, textarea').not(self);

    if (self.get(0).checked) {
      // Show conditioned field
      if(conditionedField.attr('type') == 'file') {
        conditionedField.parent(0).show(0);
      } else {
        conditionedField.show(0);
      }
      if(conditionedField.attr('multiple')) {
        conditionedField.attr('name', self.data('cName') + '[]');
        conditionedField.parents('.formily-input:first').show(0);
      } else {
        conditionedField.attr('name', self.data('cName'));
      }
      self.get(0).removeAttribute('name');
      conditionedField.focus();
    } else {
      // Hide conditioned field
      if(conditionedField.attr('type') == 'file') {
        if(confirm('Delete all files ?')){
          if(conditionedField.attr('multiple')) {
            conditionedField.parents('.formily-input:first').hide(0);
          } else {
            conditionedField.parent(0).hide(0);
          }

          var input_id = conditionedField.attr('name').match(/\[(\d+)\](\[\])?$/)[1];

          var form = conditionedField.parents('form');

          var data = {
            user_id: form.find('input[name=user_id]').val(),
            authenticity_token: form.find('input[name=authenticity_token]').val(),
            form_id: form.find('input[name=form_id]').val(),
            resource_id: form.find('input[name=resource_id]').val(),
            resource_type: form.find('input[name=resource_type]').val(),
            input_id: input_id
          };

          $.ajax({
            url: '/formily/file/delete_by_input_id',
            data: data,
            type: 'DELETE'
          });

          conditionedField.parents('.formily-input:first').find('.file_upload').remove();

          conditionedField.get(0).removeAttribute('name');
          self.attr('name', self.data('cName'));
          self.focus();
        } else {
          self.get(0).checked = true;
        }
      } else {
        conditionedField.hide(0);
        conditionedField.get(0).removeAttribute('name');
        //conditionedField.get(0).removeAttribute('value');
        self.attr('name', self.data('cName'));
        self.focus();
      }

    }

  });

});