// DateTime input
//= require formily/lib/jquery.datetimepicker.full.min
//= require formily/lib/strftime.min

$(document).on('ready formily_loaded', function(){

  $('.formily_date_time_picker').each(function(_, el){
    var dt_field = $(el);
    var cur_date = new Date();

    dt_field.datetimepicker({
      formatDate:'Y/m/d',
      scrollMonth: false,
      yearStart: cur_date.getFullYear(),
      yearEnd: cur_date.getFullYear() + 1,
      formatTime:'H:i',
      minDate:'-1970/01/02'
    });

    if(dt_field.val().match(/current/i)) {
      var dt_str = strftime('%Y/%m/%d %H:%M', cur_date);
      dt_field.val(dt_str);
    }
  });
});