$(document).on('ready formily_loaded', function() {

  var locationInputs = $('input[data-location], p.static-text[data-location], textarea[data-location]');

  if(locationInputs.length > 0) {
    if(navigator.geolocation){

      var geolocationSuccess = function(position){
        var latitude = position.coords.latitude;
        var longitude = position.coords.longitude;

        var url = window.location.protocol + '//maps.googleapis.com/maps/api/geocode/json?language=en&latlng=';

        url += latitude + ',';
        url += longitude;

        $.get(url, function(data) {
          locationInputs.each(function(_, el){
            var self = $(el);
            if(self.data('location') == 'address') {
              self.val(data.results[0].formatted_address);
            } else {
              self.val(latitude + ', ' + longitude);
            }
          });

        });
      };

      var geolocationError = function(){
        self.val('');
        console.error('Unable to retrieve your location');
      };

      navigator.geolocation.getCurrentPosition(geolocationSuccess, geolocationError);
    }
  }

});
