# coding: utf-8
class Formily::InputValue < ActiveRecord::Base

  self.table_name = 'formily_input_values'

  has_paper_trail

  belongs_to :input
  has_many :attach, foreign_key: :input_value_id, class_name: 'Formily::File'

  def get_value
    if self.attach.blank?
      if self.input.inputs.blank?
        self.input_value
      else
        self.input.inputs.map{|i| i.data.input_value.get_value}.join(', ')
      end
    else
      self.attach.file.url
    end
  end

end
