# coding: utf-8
module Formily
  module Relation
    extend ActiveSupport::Concern

    module ClassMethods

      def formily_form_related_model
        @@formily_form_related_model
      end

      def has_many_formily_forms(related_model)
        self.has_many(:many_formily_forms, as: :formilyable, class_name: 'Formily::FormilyableForm')
        @@formily_form_related_model = related_model
        # include helper methods
        self.send(:include, Formily::Relation::FormilyMethods)
        self.send(:include, Formily::Relation::HasManyMethods)

        Formily.set_formily_models(self)
        # add callback
        self.send(:after_create, :formily_after_create)
      end

    end
  end
end
