class CreateFormilyData < ActiveRecord::Migration
  def change

    create_table :formily_submits do |t|
      t.integer :form_id
      t.integer :user_id
      t.integer :resource_id
      t.integer :state , default: 0
      t.string :resource_type
      t.timestamps null: false
    end

    add_index :formily_submits, :form_id
    add_index :formily_submits, :resource_id
    add_index :formily_submits, :user_id

    create_table :formily_input_values do |t|
      t.integer :input_id
      t.integer :submit_id
      t.text :input_value
      t.timestamps null: false
    end

    add_index :formily_input_values, :input_id
    add_index :formily_input_values, :submit_id

  end
end
