$(document).ready(function(){

  var timeOutVar;

  $(document).on('keyup change', '.form_preview', function(e){
    clearTimeout(timeOutVar);
    timeOutVar = setTimeout(function(){
      var val, name, form, url, data;
      var self = $(e.target);
      form = self.parents('form');
      url = form.attr('action');
      val = self.val();
      name = self.attr('name');
      data = {};
      data[name] = val;

      $.ajax({
        url: url,
        data: data,
        type: 'PUT',
        success: function(data){
          form.attr('action', url.replace(/\d+$/, data.id));
          form.find('input[name="formily_form[id]"]').val(data.id);
          $(document).trigger('formily_form_updated');
        }
      });

    }, 500);
  });

  $(document).on('formily_form_updated', function(){

    var form = $('.ff-container form:first');

    if (form.length > 0) {
      var data = {};
      data['formily_form[id]'] = form.attr('action').match(/\d+$/)[0];

      if(form.length > 0){
        $.post(FormilyRoutes.form_preview_path(), data)
          .success(function(data){
            $('#formily_form_preview').html(data);
            $(document).trigger('formily_loaded');
            $(document).foundation();
          })
          .fail(function() {
            console.warn('Error, wrong form data !');
          });
      }
    }
  });

});