// Select options conditioned fields

$(document).ready(function(){

  var prevOption;

  $(document).on('focus click', 'select[data-formily-name]', function(e){
    var self = $(this);
    prevOption = self.find('option[value=' + self.val() + ']');
  });

  $(document).on('change', 'select[data-formily-name]', function(e){

    var self = $(this);
    var option = self.find('option[value=' + self.val() + ']');
    var conditioned_field = option.data('formilyConditioned');

    if(prevOption && prevOption.length > 0 && prevOption.data('formilyConditioned')) {
      var prevConditionedField = self.parent().find('[data-formily-conditioned-field="' + prevOption.data('formilyConditioned') + '"]');

      if(prevOption.data('formilyConditioned').match(/file/i)) {

        var input_id = prevConditionedField.attr('name').match(/\[(\d+)\](\[\])?$/)[1];

        var form = self.parents('form');

        var data = {
          user_id: form.find('input[name=user_id]').val(),
          authenticity_token: form.find('input[name=authenticity_token]').val(),
          form_id: form.find('input[name=form_id]').val(),
          resource_id: form.find('input[name=resource_id]').val(),
          resource_type: form.find('input[name=resource_type]').val(),
          input_id: input_id
        };

        $.ajax({
          url: '/formily/file/delete_by_input_id',
          data: data,
          type: 'DELETE'
        });

        prevConditionedField.get(0).removeAttribute('name');
        prevConditionedField.parent().find('.file_upload').remove();

        if(prevConditionedField.attr('multiple')) {
          prevConditionedField.parent().parent().hide(0);
        } else {
          prevConditionedField.parent().hide(0);
        }

      } else {
        prevConditionedField.get(0).removeAttribute('name');
        prevConditionedField.hide(0);
      }

    }

    self.attr('name', self.data('formilyName'));

    if(conditioned_field) {

      var i = self.parent().find('[data-formily-conditioned-field="' + conditioned_field + '"]');

      self.get(0).removeAttribute('name');

      if(i.attr('type') == 'file') {

        if(i.attr('multiple')) {
          i.parent().parent().show(0);
        } else {
          i.parent().show(0);
        }

      } else {
        i.show(0);
      }

      i.attr('name', option.data('cName'));
    }
  });

});