# coding: utf-8
class Formily::FormTypesController < FormilyController

  before_action :get_form_type, only: [:edit, :update, :destroy]


  def index
    @form_types = Formily::FormType.all
  end

  def new
    @form_type = Formily::FormType.new
  end

  def create
    form_type = Formily::FormType.new(form_type_params)
    form_type.save

    redirect_to formily_form_types_path
  end

  def edit
  end

  def update
    @form_type.update(form_type_params)
    redirect_to formily_form_types_path
  end

  def destroy
    @form_type.destroy
    redirect_to formily_form_types_path
  end


  private

    def get_form_type
      @form_type = Formily::FormType.find(params[:id])
    end

    def form_type_params
      params.require(:formily_form_type).permit(:title)
    end

end
