# coding: utf-8
class Formily::File < ActiveRecord::Base

  self.table_name = 'formily_files'

  has_paper_trail

  has_attached_file :file,
                    path: Formily.config.paperclip.path,
                    url: Formily.config.paperclip.url,
                    use_timestamp: Formily.config.paperclip.use_timestamp
  validates_attachment_content_type :file, content_type: /\A.*\z/

end
