# coding: utf-8
class Formily::MultipleFileInput < Formily::Input

  def editor_type
    'multi file'
  end

  def get_value_from_submit(submit)
    value = submit.input_values.find_by(input_id: self.id) rescue nil

    if value
      value.attach.map{|f| [f.file.url, f.id, f.file_file_name, (f.file_file_name.match(/([^.]+)\z/)[0] rescue '?')]}
    else
      []
    end
  end

end