# coding: utf-8
require 'formily/version'
require 'formily/config'
require 'formily/helpers/view_helper'
require 'formily/engine'
require 'formily/relation/formily_methods'
require 'formily/relation/has_many_methods'
require 'formily/relation'

require 'paperclip'
require 'paper_trail'
require 'jquery-rails'
require 'jquery-ui-rails'
require 'haml'
require 'browser'


module Formily

  # Get Formily gem config
  # @return [Formily::Config]
  def self.config
    @@config ||= Formily::Config.new
  end

  def self.formily_models
    @@formily_models
  end

  def self.set_formily_models(model)
    @@formily_models ||= []
    @@formily_models << model
  end

end

ActiveRecord::Base.send :include, Formily::Relation