class CreateFormilyInputs < ActiveRecord::Migration
  def change

    create_table :formily_inputs do |t|

      t.integer :form_id
      t.string :name
      t.string :label
      t.text :description
      t.string :type
      t.string :default_value
      t.text :tag_attributes
      t.integer :field_order
      t.integer :group_input_id
      t.boolean :is_deleted, default: false

      t.timestamps null: false
    end

    add_index :formily_inputs, :form_id
    add_index :formily_inputs, :group_input_id

  end
end
